#define CIF_LINE_LEN           81
#define CIF_DATA_NAME_LEN      33
#define UNDER_SCORE            '_'

/* declare a structure to hold the CIF looped data.  The ***data_values
 * pointer should be dynamically allocated to be
 * char data_values[n_rows][n_fields] is size.
 */

struct data {
      char cif_line[CIF_LINE_LEN];
      char **val_ptr;
      };

struct cif_loop {
       int n_fields;                                /* number of "columns" in the loop */
       int n_rows;                                  /* number of "rows" in the loop */
       char (*field_names)[CIF_DATA_NAME_LEN];      /* cif looped data item names */
       struct data *data_values;                    /* data values go here */ 
       };

struct cif_loop  *ProcessCIFLoop( FILE *cif, char *category );
void FreeCIFLoop( struct cif_loop *);
void MemoryFailure( char *file_name, int line_number );
