#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>

#include "ProcessCIFLoop.h"


int main( int argc, char **argv )
{
    FILE *fp;
    char *ptr = NULL;
    char *cat = "_geom_bond";
    int i = 0;
    char line[CIF_LINE_LEN];
    struct cif_loop *loop_ptr;

    if( argc != 2 ) {
      fprintf( stderr, "Usage: %s <cif_file_name>. Exiting.\n", 
               argv[0] );
      exit( EXIT_SUCCESS );
    }

    fp = fopen( argv[argc-1], "r" );
    if( !fp ) {
        perror( argv[argc-1] );
        exit( EXIT_FAILURE );
    }

    while( NULL != fgets(line, CIF_LINE_LEN, fp) ) {
        if( NULL != (ptr = strchr( line, '\n')) ) *ptr = '\0';
        if( NULL != strstr( line, "loop_" ) )
             loop_ptr = ProcessCIFLoop( fp, cat );
    }   
    for( i = 0; i < loop_ptr->n_rows; i++ ) {
       fprintf( stdout, "%s %s %s %s %s %s\n", 
               loop_ptr->data_values[i].val_ptr[0],
               loop_ptr->data_values[i].val_ptr[1],
               loop_ptr->data_values[i].val_ptr[2],
               loop_ptr->data_values[i].val_ptr[3],
               loop_ptr->data_values[i].val_ptr[4],
               loop_ptr->data_values[i].val_ptr[5] );
    }

    FreeCIFLoop( loop_ptr );
    exit( EXIT_SUCCESS );
}
